/*
 * Copyright 2021 iserge, Gis4Fun.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *  Experimental features must still uphold Cesium's quality standards. Here are some guidelines:
 *
 *  Experimental features must have high unit test coverage like any other feature.
 *  Experimental features are intended for large features where there is benefit of merging some of the code sooner (e.g. to avoid long-running staging branches)
 *  Experimental flags should be short-lived. Make it clear in the PR what it would take to promote the feature to a regular feature.
 *  To avoid cluttering the code, check the flag in as few places as possible. Ideally this would be a single place.
 */
package org.cesiumjs.cs.scene.experimental;
